﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Xml;

namespace Siddin_2._1
{
    public partial class Main : Form
    {
        Boolean demo = true;
        XmlDocument xml_document;
        public Main()
        {
            InitializeComponent();
        }
        siddin21.Job[] selected_job;
        siddin21.Job[] jobs;
        siddin21.ImportClient importClient;
        string ticket;
        Guid jobId;
        private void button1_Click(object sender, EventArgs e)
        {

            try
            {

                siddin21.LoginRequest loginRequest = new siddin21.LoginRequest();
                loginRequest.UserName = textBox2.Text;
                loginRequest.Password = textBox3.Text;

                siddin21.LoginRequest1 loginRequest1 = new siddin21.LoginRequest1();
                loginRequest1.LoginRequest = loginRequest;
                if (demo)
                  importClient = new siddin21.ImportClient("Import", "https://demo.krd.pl/siddin/2.1/Import.asmx");
                else
                    importClient = new siddin21.ImportClient("Import", "https://services.krd.pl/siddin/2.1/Import.asmx");


                ticket = importClient.Login(loginRequest);

                if (!String.IsNullOrEmpty(ticket))
                {
                    label1.Text = "Zalogowany jako: " + loginRequest.UserName + " na środowisku " + (demo ? "DEMO" : "PROD");

                }
                else
                    label1.Text = "Niezalogowany";

            }
            catch (Exception ex) { textBox1.Text = "Błąd!! " + ex.ToString(); }

        }




        private siddin21.ChunkBag UpladChunkRequest(string xml)
        {
            siddin21.ChunkBag chunkBag = null;
            int actual_char = 0;

            int max_chunk_size = 300;

            for (actual_char = 0; actual_char < xml.Length; )
            {


                siddin21.UpladChunkRequest upladChunkRequest;



                upladChunkRequest = new siddin21.UpladChunkRequest()
                {
                    ChunkBag = chunkBag,
                    Ticket = ticket,
                    Data = xml.Substring(actual_char, actual_char + max_chunk_size > xml.Length ? xml.Length - actual_char : max_chunk_size)

                };
                actual_char = actual_char + max_chunk_size;
                try
                {
                    chunkBag = importClient.UploadChunk(upladChunkRequest);
                }
                catch (Exception ex)
                {
                    textBox1.Text = "Błąd!! " + ex.ToString();
                }


            }
            return chunkBag;
        }

        private void CloseChunkBag(siddin21.ChunkBag chunkBag)
        {
            try
            {
                chunkBag.NicciVersion = siddin21.NicciVersionEnum.Version_3_1;
                siddin21.CloseChunkBagRequest closeChunkBagRequest = new siddin21.CloseChunkBagRequest();
                closeChunkBagRequest.ChunkBag = chunkBag;
                closeChunkBagRequest.Ticket = ticket;
                closeChunkBagRequest.GetDifference = roznicowa.Checked;

                jobId = importClient.CloseChunkBag(closeChunkBagRequest);
            }
            catch (Exception ex)
            {
                textBox1.Text = "Błąd!! " + ex.ToString();
            }
        }

        private void button4_v2_Click(object sender, EventArgs e)
        {


          string xml = "<Input version=\"3.1\" generator=\"KRD Samples\"><InformationManagement><Order ID=\"1\">"
                       +"<GetInformations><Cases><Pager><StartIndex>0</StartIndex><Count>max</Count></Pager></Cases></GetInformations>"
                       + "</Order>"
                       + "</InformationManagement>"
                       + "</Input>";
                 



            CloseChunkBag(UpladChunkRequest(xml));
            textBox1.Text = "Zlecanie zakończone";
        }

        private void button2_Click(object sender, EventArgs e)
        {
            jobs = importClient.GetJobs(new siddin21.GetJobsRequest() { GetAll = true, Ticket = ticket });
            listBox1.Items.Clear();
            listBox1.DisplayMember = "name";
            foreach (siddin21.Job job in jobs)
            {
                JobExtended ex = new JobExtended(job);
                listBox1.Items.Add(ex);
            }


        }

        private void button3_Click(object sender, EventArgs e)
        {
            xml_document = null;
            GC.Collect();
            GC.WaitForFullGCComplete();
            GC.Collect();
            int number;
            textBox1.Text = "";
            StringBuilder stringBuilder_xml = new StringBuilder();
            siddin21.ChunkBag chunkBag = importClient.GetChunkBag(new siddin21.GetChunkBagRequest() { JobId = ((JobExtended)listBox1.SelectedItem).ID, Ticket = ticket, ChunkSize = 1000000 });
            for (number = 1; number <= chunkBag.Count; number++)
            {
                siddin21.DownloadChunkRequest downloadChunkRequest = new siddin21.DownloadChunkRequest();
                downloadChunkRequest.Number = number;
                downloadChunkRequest.Ticket = ticket;
                downloadChunkRequest.ChunkBag = chunkBag;
                textBox1.Text = "";

                try
                {
                    stringBuilder_xml.Append(importClient.DownloadChunk(downloadChunkRequest));
                    downloadChunkRequest = null;
                    GC.Collect();
                    GC.WaitForFullGCComplete();
                    GC.Collect();
                }

                catch (Exception)
                {
                    button1_Click(sender, e);
                    number--;
                }
            }
            textBox1.Text = "Sciągnąłem ładuję do XML...\n";

            xml_document = new XmlDocument();
            try
            {
                String string_xml = stringBuilder_xml.ToString();
                stringBuilder_xml.Clear();
                stringBuilder_xml = null;
                GC.Collect();
                GC.WaitForFullGCComplete();
                GC.Collect();
                xml_document.LoadXml(string_xml);
                textBox1.Text += "załadowałem do XML...";
                string_xml = null;
                GC.Collect();
                GC.WaitForFullGCComplete();
                GC.Collect();

            }
            catch (System.OutOfMemoryException)
            {
                GC.Collect();
                GC.WaitForFullGCComplete();
                GC.Collect();
                textBox1.Text += "\nOutOfMemmory...\n";
            }
            catch (Exception ex)
            {

                textBox1.Text += "\n"+ex.Message;
            }
            textBox1.Text = xml_document.OuterXml.ToString();

        }


        private void button6_Click(object sender, EventArgs e)
        {
            SaveFileDialog saveReport = new SaveFileDialog();
            saveReport.Filter = "Text Files | *.xml";
            saveReport.ShowDialog();
            button3_Click(sender, e);
            xml_document.Save(saveReport.FileName);
        }

        private void button7_Click(object sender, EventArgs e)
        {
            demo = !demo;
            if (demo)
                textBox4.Text = "Środowisko DEMO";
            else
                textBox4.Text = "Środowisko Produkcyjne";
        }

        private void button5_Click(object sender, EventArgs e)
        {
            selected_job = importClient.GetJobs(new siddin21.GetJobsRequest() { Ticket = ticket, JobId = ((JobExtended)listBox1.SelectedItem).ID });



            textBox1.Text = "";
            for (int ii = 0; ii < selected_job.Length; ii++)
            {
                textBox1.Text += selected_job[ii].JobNumber + " " + selected_job[ii].Status + " " + selected_job[ii].QueueDate + " " + selected_job[ii].Progress + "%\n";
            }
        }

        private void button8_Click(object sender, EventArgs e)
        {
            string xml_input = null;
            OpenFileDialog openFileDialog = new OpenFileDialog();
            openFileDialog.Filter = "Text Files | *.xml";


            if (openFileDialog.ShowDialog() == DialogResult.OK)
            {
                try
                {

                    System.IO.Stream fileStream = openFileDialog.OpenFile();

                    using (System.IO.StreamReader reader = new System.IO.StreamReader(fileStream))
                    {
                        xml_input = reader.ReadToEnd();
                    }
                    fileStream.Close();
                    CloseChunkBag(UpladChunkRequest(xml_input));
                    textBox1.Text = "Zlecanie zakończone";
                }

                catch (Exception e1)
                {
                    textBox1.Text += e1.ToString();
                }
            
            
            }
        }


    }

}
